/**
 * Borrow from https://github.com/excalidraw/excalidraw/blob/master/packages/excalidraw/change.ts#L399
 */
import { AppState } from '../context';
import { Change } from './Change';
import { SceneElementsMap } from './ElementsChange';
export declare class AppStateChange implements Change<AppState> {
    private readonly delta;
    private constructor();
    static empty(): AppStateChange;
    static calculate<T extends AppState>(prevAppState: T, nextAppState: T): AppStateChange;
    inverse(): AppStateChange;
    applyTo(appState: AppState, nextElements: SceneElementsMap): [AppState, boolean];
    /**
     * Mutates `nextAppState` be filtering out state related to deleted elements.
     *
     * @returns `true` if a visible change is found, `false` otherwise.
     */
    private filterInvisibleChanges;
    isEmpty(): boolean;
}
