"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefaultAppState = exports.apiContext = exports.nodesContext = exports.appStateContext = exports.Task = void 0;
const context_1 = require("@lit/context");
const ecs_1 = require("@infinite-canvas-tutorial/ecs");
var Task;
(function (Task) {
    Task["SHOW_LAYERS_PANEL"] = "show-layers-panel";
    Task["SHOW_PROPERTIES_PANEL"] = "show-properties-panel";
})(Task || (exports.Task = Task = {}));
exports.appStateContext = (0, context_1.createContext)(Symbol('appAtate'));
exports.nodesContext = (0, context_1.createContext)(Symbol('nodes'));
exports.apiContext = (0, context_1.createContext)(Symbol('api'));
const getDefaultAppState = () => {
    return {
        // TODO: Flatten theme
        theme: {
            mode: ecs_1.ThemeMode.LIGHT,
            colors: {
                [ecs_1.ThemeMode.LIGHT]: {},
                [ecs_1.ThemeMode.DARK]: {},
            },
        },
        checkboardStyle: ecs_1.CheckboardStyle.GRID,
        cameraZoom: 1,
        penbarAll: [ecs_1.Pen.HAND, ecs_1.Pen.SELECT, ecs_1.Pen.DRAW_RECT],
        penbarSelected: [ecs_1.Pen.HAND],
        taskbarAll: [Task.SHOW_LAYERS_PANEL, Task.SHOW_PROPERTIES_PANEL],
        taskbarSelected: [],
        layersSelected: [],
        propertiesOpened: [],
    };
};
exports.getDefaultAppState = getDefaultAppState;
//# sourceMappingURL=context.js.map