"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UIPlugin = void 0;
const ecs_1 = require("@infinite-canvas-tutorial/ecs");
const systems_1 = require("../systems");
const components_1 = require("../components");
const UIPlugin = () => {
    (0, ecs_1.component)(components_1.Container);
    /**
     * Solve the following error:
     * Uncaught (in promise) p: Multiple component types named o; names must be unique at eG.createSystems
     *
     * Usually, this error is caused when the code is bundled.
     */
    Object.defineProperty(systems_1.InitCanvasSystem, 'name', {
        value: 'InitCanvasSystem',
    });
    Object.defineProperty(systems_1.ZoomLevelSystem, 'name', {
        value: 'ZoomLevelSystem',
    });
    Object.defineProperty(systems_1.DownloadScreenshotSystem, 'name', {
        value: 'DownloadScreenshotSystem',
    });
    (0, ecs_1.system)((s) => s.after(ecs_1.PreStartUp).before(systems_1.ZoomLevelSystem).beforeWritersOf(ecs_1.Canvas))(systems_1.InitCanvasSystem);
    (0, ecs_1.system)((s) => s
        .inAnyOrderWithWritersOf(ecs_1.Camera)
        .after(ecs_1.SetupDevice, ecs_1.SyncSimpleTransforms, ecs_1.PropagateTransforms))(systems_1.ZoomLevelSystem);
    (0, ecs_1.system)((s) => s.before(ecs_1.PreStartUp))(systems_1.DownloadScreenshotSystem);
};
exports.UIPlugin = UIPlugin;
//# sourceMappingURL=UI.js.map